(* file: strings.ml
   author: Bob Muller

   CS1103 Computer Science I Honors

   Examples of working with strings.

   isSubstring : string -> string -> bool
*)
let isSubstring subj text =
  let n = String.length subj in
  let rec matchesHere i j =
    match j = n with
    | true  -> true
    | false -> (subj.[j] = text.[i + j]) && matchesHere i (j + 1) in
  let rec loop i =
    match i > (String.length text) - n with
    | true  -> false
    | false -> (matchesHere i 0) || loop (i + 1)
  in
  loop 0

exception Found

(* isSubstring : string -> string -> bool

   This version is a little artificial, attempting to compensate for OCaml's
   lack of a an "early return" by throwing an exception with the subject
   string is found.
 *)
let isSubstring subj text =
  let n = String.length subj in
  try
    for i = 0 to (String.length text) - n do
      let count = ref 0
      in
      for j = 0 to n - 1 do
        match subj.[j] = text.[i + j] with
        | true  -> count := !count + 1
        | false -> ()
      done ;
      if !count = n then raise Found else ()
    done ;
    false
  with
  | Found -> true
